Scriptname AAACrimeDecayConfig extends SKI_ConfigBase  



AAACrimeDecayScript Property CrimeDecay Auto

int aOID
int bOID
int cOID

float PercKeep = 90.0;
int FlatDrop = 5;
bool UseHolds = false;

event OnPageReset(string page)
	PercKeep = CrimeDecay.PercKeep * 100
	FlatDrop = CrimeDecay.FlatDrop
	UseHolds = CrimeDecay.UseHolds
	SetCursorFillMode(TOP_TO_BOTTOM)
	aOID = AddSliderOption("Keep: ", PercKeep, "{0}%")
	bOID = AddSliderOption("Flat Loss: ",FlatDrop, "{0} gold")
	cOID = AddToggleOption("Avoid entire holds?",UseHolds)
endEvent

event OnOptionSelect(int option)
	If (option == cOID)
		CrimeDecay.UseHolds = !UseHolds
		UseHolds = !UseHolds
		SetToggleOptionValue(cOID,UseHolds)
	EndIf
endEvent

event OnOptionDefault(int option)
	if (option == aOID)
		PercKeep = 90.0
		CrimeDecay.PercKeep = 0.9
		SetSliderOptionValue(aOID, PercKeep)
	elseIf (option == bOID)
		FlatDrop = 5
		CrimeDecay.FlatDrop = 5
		SetSliderOptionValue(bOID, FlatDrop)
	elseIf (option == cOID)
		UseHolds = false
		CrimeDecay.UseHolds = false
		SetToggleOptionValue(cOID,UseHolds)
	endIf
endEvent


event OnOptionHighlight(int option)
	if (option == aOID)
		SetInfoText("Determines the basic proportion of your crime bounty that is KEPT when the day changes.\nNeeds to be less than 1 to lose large bounties in reasonable timeframes.\nDefault is 90%")
	elseIf (option == bOID)
		SetInfoText("Determines the flat daily reduction in bounty, after the above percentage-based loss.\nNeeds to be greater than 0 to have small bounties actually go to zero.\nDefault is 5")
	elseIf (option == cOID)
		SetInfoText("If set to true, your bounty in a hold will only decrease if you are completely outside of that hold\nat midnight, rather than simply outside the hold's primary settlement.\nDefaults to false.  May not reliably prevent decay in the wilderness of a hold.")
	endIf
endEvent


event OnOptionSliderOpen(int option)
    if (option == aOID)
        SetSliderDialogStartValue(PercKeep)
        SetSliderDialogDefaultValue(90)
        SetSliderDialogRange(0, 100)
        SetSliderDialogInterval(1)

    elseIf (option == bOID)
        SetSliderDialogStartValue(FlatDrop)
        SetSliderDialogDefaultValue(5)
        SetSliderDialogRange(0,100)
        SetSliderDialogInterval(1)
    endIf
endEvent


event OnOptionSliderAccept(int option, float value)
    if (option == aOID)
        PercKeep = value
	 CrimeDecay.PercKeep = PercKeep / 100
	 SetSliderOptionValue(aOID, PercKeep, "{0}%")

    elseIf (option == bOID)
        FlatDrop = value as int
	 CrimeDecay.FlatDrop = FlatDrop
        SetSliderOptionValue(bOID, value, "{0} gold")
    endIf
endEvent