Scriptname AAACrimeDecayScript extends Quest  

GlobalVariable Property GameHour Auto
Float Property NextUpdateTime Auto
Float Property TempForMaths Auto
Int Property Goldilocks Auto


;Config
Bool Property UseHolds Auto
Float Property PercKeep Auto
Int Property FlatDrop Auto
Bool Property MessagesOn Auto



Int Function DecayTo(int LastValue) 
 
	TempForMaths = (LastValue as Float) * PercKeep
	TempForMaths -= (FlatDrop as Float)
	If TempForMaths < 0
		TempForMaths = 0.0
	EndIf

	Return (TempForMaths as Int)
 
EndFunction


Event OnInit()
	PercKeep = 0.9
	FlatDrop = 5
	UseHolds = False
	MessagesOn = True

	NextUpdateTime = Utility.GetCurrentGameTime() + (24 - GameHour.GetValue())/24		;Target time is midnight
	RegisterForSingleUpdateGameTime(24 - GameHour.GetValue()) 							;Set script to update at midnight game time
EndEvent


Event OnUpdate()
	Debug.Notification("Switching to game time updates for crime decay.")
	RegisterForSingleUpdateGameTime(24 - GameHour.GetValue())
EndEvent


Event OnUpdateGameTime()

	;Debug.Notification("Running update check.")


	If Utility.GetCurrentGameTime() > NextUpdateTime		;Time for to drop some bounties
		;Debug.Notification("Updating bounties.")

		If CrimeFactionEastmarch.GetCrimeGold() && !Game.GetPlayer().IsInLocation(WindhelmLocation) && (!Game.GetPlayer().IsInLocation(EastmarchHoldLocation) || !UseHolds )
			Goldilocks = CrimeFactionEastmarch.GetCrimeGold()
			Goldilocks = DecayTo(Goldilocks)
			CrimeFactionEastmarch.SetCrimeGold(Goldilocks)
			CrimeFactionEastmarch.SetCrimeGoldViolent(0)
			If !Goldilocks
				Debug.Notification("I'd wager that the guards of Windhelm have forgotten about me by now.")
				CrimeFactionEastmarch.PlayerPayCrimeGold(0,0)		;Pay 0-gold 'bounty' without going to jail or removing stolen items.  Probably unnecessary, but.
			EndIf
		EndIf

		If CrimeFactionFalkreath.GetCrimeGold() && !Game.GetPlayer().IsInLocation(FalkreathLocation) && (!Game.GetPlayer().IsInLocation(FalkreathHoldLocation) || !UseHolds )
			Goldilocks = CrimeFactionFalkreath.GetCrimeGold()
			Goldilocks = DecayTo(Goldilocks)
			CrimeFactionFalkreath.SetCrimeGold(Goldilocks)
			CrimeFactionFalkreath.SetCrimeGoldViolent(0)
			If !Goldilocks
				Debug.Notification("The heat's probably blown over in Falkreath.")
				CrimeFactionFalkreath.PlayerPayCrimeGold(0,0)
			EndIf
		EndIf

		If CrimeFactionHaafingar.GetCrimeGold() && !Game.GetPlayer().IsInLocation(SolitudeLocation) && (!Game.GetPlayer().IsInLocation(HaafingarHoldLocation) || !UseHolds )
			Goldilocks = CrimeFactionHaafingar.GetCrimeGold()
			Goldilocks = DecayTo(Goldilocks)
			CrimeFactionHaafingar.SetCrimeGold(Goldilocks)
			CrimeFactionHaafingar.SetCrimeGoldViolent(0)
			If !Goldilocks
				Debug.Notification("Solitude should be safe enough for me to visit now.")
				CrimeFactionHaafingar.PlayerPayCrimeGold(0,0)
			EndIf
		EndIf

		If CrimeFactionHjaalmarch.GetCrimeGold() && !Game.GetPlayer().IsInLocation(MorthalLocation) && (!Game.GetPlayer().IsInLocation(HjaalmarchHoldLocation) || !UseHolds )
			Goldilocks = CrimeFactionHjaalmarch.GetCrimeGold()
			Goldilocks = DecayTo(Goldilocks)
			CrimeFactionHjaalmarch.SetCrimeGold(Goldilocks)
			CrimeFactionHjaalmarch.SetCrimeGoldViolent(0)
			If !Goldilocks
				Debug.Notification("I don't think they're looking for me in Morthal anymore.")
				CrimeFactionHjaalmarch.PlayerPayCrimeGold(0,0)
			EndIf
		EndIf
			
		If CrimeFactionOrcs.GetCrimeGold()
			Goldilocks = CrimeFactionOrcs.GetCrimeGold()
			Goldilocks = DecayTo(Goldilocks)
			CrimeFactionOrcs.SetCrimeGold(Goldilocks)
			CrimeFactionOrcs.SetCrimeGoldViolent(0)
			If !Goldilocks
				Debug.Notification("The strongholds have surely forgotten my little indiscretion.")
				CrimeFactionOrcs.PlayerPayCrimeGold(0,0)
			EndIf
		EndIf

		If CrimeFactionPale.GetCrimeGold() && !Game.GetPlayer().IsInLocation(DawnstarLocation) && (!Game.GetPlayer().IsInLocation(PaleHoldLocation) || !UseHolds )
			Goldilocks = CrimeFactionPale.GetCrimeGold()
			Goldilocks = DecayTo(Goldilocks)
			CrimeFactionPale.SetCrimeGold(Goldilocks)
			CrimeFactionPale.SetCrimeGoldViolent(0)
			If !Goldilocks
				Debug.Notification("Dawnstar will have other criminals to worry about by now.")
				CrimeFactionPale.PlayerPayCrimeGold(0,0)
			EndIf
		EndIf

		If CrimeFactionReach.GetCrimeGold() && !Game.GetPlayer().IsInLocation(MarkarthLocation) && (!Game.GetPlayer().IsInLocation(ReachHoldLocation) || !UseHolds )
			Goldilocks = CrimeFactionReach.GetCrimeGold()
			Goldilocks = DecayTo(Goldilocks)
			CrimeFactionReach.SetCrimeGold(Goldilocks)
			CrimeFactionReach.SetCrimeGoldViolent(0)
			If !Goldilocks
				Debug.Notification("Pretty sure I'm off the boards in Markarth, after this long.")
				CrimeFactionReach.PlayerPayCrimeGold(0,0)
			EndIf
		EndIf

		If CrimeFactionRift.GetCrimeGold() && !Game.GetPlayer().IsInLocation(RiftenLocation) && (!Game.GetPlayer().IsInLocation(RiftenHoldLocation) || !UseHolds )
			Goldilocks = CrimeFactionRift.GetCrimeGold()
			Goldilocks = DecayTo(Goldilocks)
			CrimeFactionRift.SetCrimeGold(Goldilocks)
			CrimeFactionRift.SetCrimeGoldViolent(0)
			If !Goldilocks
				Debug.Notification("Riften's full of criminals anyway.  They won't remember me.")
				CrimeFactionRift.PlayerPayCrimeGold(0,0)
			EndIf
		EndIf

		If CrimeFactionWhiterun.GetCrimeGold() && !Game.GetPlayer().IsInLocation(WhiterunLocation) && (!Game.GetPlayer().IsInLocation(WhiterunHoldLocation) || !UseHolds )
			Goldilocks = CrimeFactionWhiterun.GetCrimeGold()
			Goldilocks = DecayTo(Goldilocks)
			CrimeFactionWhiterun.SetCrimeGold(Goldilocks)
			CrimeFactionWhiterun.SetCrimeGoldViolent(0)
			If !Goldilocks
				Debug.Notification("Should be safe to say hello to the guards in Whiterun again.")
				CrimeFactionWhiterun.PlayerPayCrimeGold(0,0)
			EndIf
		EndIf

		If CrimeFactionWinterhold.GetCrimeGold() && !Game.GetPlayer().IsInLocation(WinterholdLocation) && !Game.GetPlayer().IsInLocation(WinterholdCollegeLocation) && (!Game.GetPlayer().IsInLocation(WinterholdHoldLocation) || !UseHolds )
			Goldilocks = CrimeFactionWinterhold.GetCrimeGold()
			Goldilocks = DecayTo(Goldilocks)
			CrimeFactionWinterhold.SetCrimeGold(Goldilocks)
			CrimeFactionWinterhold.SetCrimeGoldViolent(0)
			If !Goldilocks
				Debug.Notification("That whole unpleasantness in Winterhold has probably blown over.")
				CrimeFactionWinterhold.PlayerPayCrimeGold(0,0)
			EndIf
		EndIf
		NextUpdateTime = Utility.GetCurrentGameTime() + (24 - GameHour.GetValue())/24
	EndIf
	RegisterForSingleUpdateGameTime(24 - GameHour.GetValue())
EndEvent

Faction Property CrimeFactionEastmarch  Auto  

Faction Property CrimeFactionFalkreath  Auto  

Faction Property CrimeFactionHaafingar  Auto  

Faction Property CrimeFactionHjaalmarch  Auto  

Faction Property CrimeFactionOrcs  Auto  

Faction Property CrimeFactionPale  Auto  

Faction Property CrimeFactionReach  Auto  

Faction Property CrimeFactionRift  Auto  

Faction Property CrimeFactionWhiterun  Auto  

Faction Property CrimeFactionWinterhold  Auto  

Location Property EastmarchHoldLocation  Auto  

Location Property WindhelmLocation  Auto  

Location Property FalkreathHoldLocation  Auto  

Location Property FalkreathLocation  Auto  

Location Property HaafingarHoldLocation  Auto  

Location Property SolitudeLocation  Auto  

Location Property HjaalmarchHoldLocation  Auto  

Location Property MorthalLocation  Auto  

Location Property PaleHoldLocation  Auto  

Location Property DawnstarLocation  Auto  

Location Property ReachHoldLocation  Auto  

Location Property MarkarthLocation  Auto  

Location Property RiftenHoldLocation  Auto  

Location Property RiftenLocation  Auto  

Location Property WhiterunHoldLocation  Auto  

Location Property WhiterunLocation  Auto  

Location Property WinterholdHoldLocation  Auto  

Location Property WinterholdLocation  Auto  

Location Property WinterholdCollegeLocation  Auto  
